﻿using Infragistics.Web.UI.ListControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web.UI.WebControls;

namespace WebDataGrid.WebDropDown.Cascading
{
    public partial class Default : System.Web.UI.Page
    {
        public static IList<Category> categories;
        public static IList<Book> books;

        public static IList<Book> bookOrders;

        public Default()
        {
            if (categories == null)
            {
                categories = GenerateCategories();
                books = GenerateBookOrders();
                bookOrders = GenerateBookOrders();
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            wdg.DataSource = bookOrders;
            categoryBook_ddp.EditorControl.DataSource = GenerateCategories();
            categoryBook_ddp.EditorControl.TextField = "Name";
        }

        public static IList<Category> GenerateCategories()
        {
            var _categories = new List<Category>();

            _categories.Add(new Category { CategoryId = 0, Name = "PHP" });
            _categories.Add(new Category { CategoryId = 1, Name = "ASP" });
            _categories.Add(new Category { CategoryId = 2, Name = "JAVA" });

            return _categories;
        }
        public IList<Book> GenerateBookOrders()
        {
            var _books = new List<Book>();

            _books.Add(new Book() { BookId = 0, CategoryBook = categories[0].Name, Title = "Pro PHP: Patterns, Frameworks, Testing and More" });
            _books.Add(new Book() { BookId = 1, CategoryBook = categories[0].Name, Title = "Beginning PHP and MySQL: From Novice to Professional, Third Edition" });
            _books.Add(new Book() { BookId = 2, CategoryBook = categories[1].Name, Title = "Foundations of ASP.NET AJAX" });
            _books.Add(new Book() { BookId = 3, CategoryBook = categories[1].Name, Title = "Beginning ASP.NET 3.5 in C# 2008: From Novice to Professional, Second Edition" });
            _books.Add(new Book() { BookId = 4, CategoryBook = categories[1].Name, Title = "Pro ASP.NET MVC Framework" });
            _books.Add(new Book() { BookId = 5, CategoryBook = categories[1].Name, Title = "Beginning ASP.NET E-Commerce in C#: From Novice to Professional" });
            _books.Add(new Book() { BookId = 6, CategoryBook = categories[2].Name, Title = "Beginning Java™ EE 6 Platform with GlassFish™ 3: From Novice to Professional" });
            _books.Add(new Book() { BookId = 7, CategoryBook = categories[2].Name, Title = "Practical Liferay: Java–based Portal Applications Development" });

            return _books;
        }

        protected void TitleProvider_ItemsRequested(object sender, DropDownItemsRequestedEventArgs e)
        {
            string param = e.Value.ToString();

            IList<Book> list = books
                                .ToList()
                                .Where(p => p.CategoryBook == param)
                                .ToList();

            ((Infragistics.Web.UI.ListControls.WebDropDown)sender).DataSource = list;
            ((Infragistics.Web.UI.ListControls.WebDropDown)sender).TextField = "Title";
            ((Infragistics.Web.UI.ListControls.WebDropDown)sender).Items.Clear();
            ((Infragistics.Web.UI.ListControls.WebDropDown)sender).DataBind();
        }

        public class Book
        {
            public string CategoryBook { get; set; }
            public int BookId { get; set; }
            public string Title { get; set; }
        }

        public class Category
        {
            public int CategoryId { get; set; }
            public string Name { get; set; }
        }

        protected void categoryBook_provider_ValueChanged()
        {

        }
    }
}